function [Out,bDs]=set_datas(N,verbose,varargin)
  % example of 'set_fun' function used in bench
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('d',[2,2],@(x) ismember(length(x),[1,2]));
  p.addParamValue('fprintf',@(varargin) fprintf(varargin{:}));
  p.addParamValue('type','amat',@(s) ismember(lower(s),{'amat','mat','array1d','constant','scalar'}));
  p.addParamValue('class','double');
  p.addParamValue('complex',false,@islogical);
  p.parse(varargin{:});
  R=p.Results;
  %mattype=R.mattype;
  Fprintf=R.fprintf;
  d=R.d;classname=R.class;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  
  if ismember(classname,{'double','single'})
    if R.complex 
      amatrand=@(N,m,n) complex(fc_amat.random.randn(N,m,n,classname),fc_amat.random.randn(N,m,n,classname));
      array1drand=@(N) complex(randn(N,1,classname),randn(N,1,classname));
      matrand=@(m,n) complex(randn(m,n,classname),randn(m,n,classname));
      scalarrand=@(m,n) complex(randn(classname),randn(classname));
    else
      amatrand=@(N,m,n) fc_amat.random.randn(N,m,n,classname);
      array1drand=@(N) randn(N,1,classname);
      matrand=@(m,n) randn(m,n,classname);
      scalarrand=@(m,n) randn(classname);
    end
  else
    b=100;if classname(1)=='u', a=0;else a=-b;end
    if R.complex 
      amatrand=@(N,m,n) complex(fc_amat.random.randi([a,b],N,m,n,classname),fc_amat.random.randi([a,b],N,m,n,classname));
      array1drand=@(N) complex(randi([a,b],N,1,classname),randi([a,b],N,1,classname));
      matrand=@(m,n) complex(randi([a,b],m,n,classname),randi([a,b],m,n,classname));
      scalarrand=@(m,n) complex(randi([a,b],classname),randi([a,b],classname));
    else
      amatrand=@(N,m,n) fc_amat.random.randi([a,b],N,m,n,classname);
      array1drand=@(N) randi([a,b],N,1,classname);
      matrand=@(m,n) randi([a,b],m,n,classname);
      scalarrand=@(m,n) randi([a,b],classname);
    end
  end
  
  if length(d)==1, d(2)=d(1);end
  switch lower(R.type)
    case 'amat'
      A=amatrand(N,d(1),d(2));
      classname=subclass(A);
    case 'mat'
      A=matrand(d(1),d(2));
      classname=class(A);
    case 'array1d'
      A=array1drand(N,1); 
      classname=class(A);
    case {'constant','scalar'}
      A=scalarrand();  
      classname=class(A);
  end
  if verbose
    if ~isreal(A)
      str=['complex ',classname];
    else 
      str=classname; 
    end
    switch lower(R.type)
    case 'amat'
      Fprintf('# -> amat[%s] with (N,nr,nc)=(%d,%d,%d),  size=[%s]\n',str,N,d(1),d(2),num2str(size(A)));
    case 'mat'
      Fprintf('# -> matrix[%s] with (m,n)=(%d,%d),  size=[%s]\n',str,d(1),d(2),num2str(size(A)));
    case 'array1d'
      Fprintf('# -> 1D-array[%s] with  N=%d,  size=[%s]\n',str,N,num2str(size(A)));
    case {'constant','scalar'}
      Fprintf('# -> Scalar[%s] with  size=[%s]\n',str,num2str(size(A)));
    end
  end
  bDs(1)=fc_bench.bdata('N',N,'%d',10);
  Out={A};
end


